// -*- C++ -*-
//  Boost general library 'format'  ---------------------------
//  See http://www.boost.org for updates, documentation, and revision history.

//  (C) Samuel Krempp 2001
//                  krempp@crans.ens-cachan.fr
//  Permission to copy, use, modify, sell and
//  distribute this software is granted provided this copyright notice appears
//  in all copies. This software is provided "as is" without express or implied
//  warranty, and with no claim as to its suitability for any purpose.

// ------------------------------------------------------------------------------
// sample_formats.cc :  format δŪʻȤ
// ------------------------------------------------------------------------------

#include <iostream>
#include <iomanip>

#include "boost/format.hpp"

int main(){
    using namespace std;
    using boost::format;
    using boost::io::group;
    using boost::io::str;
    stringstream oss;

    
    // ¤ؤ :
    cout << format("%1% %2% %3% %2% %1% \n") % "o" % "oo" % "O"; // 'ץ'ʥ
    //          prints  "o oo O oo o \n"
    cout << format("(x,y) = (%1$+5d,%2$+5d) \n") % -23 % 35;     // POSIX  printf Υ


    // No reordering :
    cout << format("writing %s,  x=%s : %d-th step \n") % "toto" % 40.23 % 50; 
    //          "writing toto,  x=40.23 : 50-th step \n" ɽ

    cout << format("(x,y) = (%+5d,%+5d) \n") % -23 % 35;
    cout << format("(x,y) = (%|+5|,%|+5|) \n") % -23 % 35;
    cout << format("(x,y) = (%|1$+5|,%|2$+5|) \n") % -23 % 35;
    //   all those are the same,  it prints  "(x,y) = (  -23,  +35) \n"
    //   ٤Ʊ "(x,y) = (  -23,  +35) \n" ɽ



    // 'group' Ѥƥޥ˥ԥ졼Ȥ :
    cout << format("%2% %1% %2%\n")  % 1   % group(setfill('X'), hex, setw(4), 16+3) ;
    // "XX13 1 XX13\n" ɽ


    // printf ̿ηե饰Ͻ񼰲ץϤΤ˻Ȥ뤳ȤǤ :
    cout <<  format("_%1$4d_ is : _%1$#4x_, _%1$#4o_, and _%1$s_ by default\n")  % 18;
    //          "_  18_ is : _0x12_, _ 022_, and _18_ by default\n" ɽ

    // ͤʸФ :
    std::string s;
    s= str( format(" %d %d ") % 11 % 22 );
    assert( s == " 11 22 ");


    // -----------------------------------------------
    //  %%  '%' ɽ

    cout << format("%%##%#x ") % 20 << endl;
    //          "%##0x14 " ɽ
 

    // -----------------------------------------------
    //    

    // ¿ϡפʰͿ㳰Ф :
    try {
      format(" %1% %1% ") % 101 % 102;
      // ʸ<b>Ĥ</b>󻲾Ȥ롣ĤǤϤʤ
      // äơĤΰͿ뤳Ȥϥ顼Ǥ
    }
    catch (boost::io::too_many_args& exc) { 
      cerr <<  exc.what() << "\n\t\t***Dont worry, that was planned\n";
    }

    
    // Too few arguments when requesting the result will also throw an exception :
    // ʤޤ̤׵ᤷ㳰Ф :
    try {
      cerr << format(" %|3$| ") % 101; 
      // %1$  %2$ ȤƤʤäȤƤ⡢ĤΰͿ٤Ǥ
    }
    catch (boost::io::too_few_args& exc) { 
      cerr <<  exc.what() << "\n\t\t***Dont worry, that was planned\n";
    }

    
    cerr << "\n\nEverything went OK, exiting. \n";
    return 0;
}
